%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: lstm_fit.m,v 1.6 2017/06/28 13:41:22 mechanoid Exp $


% - - - - - - - - - - - - - - - - 
function [W,er_hist] = lstm_fit(W,X,y,Xc,yc),
   [W,er_hist] = lstm_fit_gradient_descent(W,X,y,Xc,yc);
endfunction

% - - - - - - - - - - - - - - - - 
% метод простого градиентного спуска
function [W,er_hist] = lstm_fit_gradient_descent(W,X,y,Xc,yc),
   a = 0.01 ; % скорость обучения
   er_max = 0.07 ; % порог допустимой ошибки
   n = 11e3 ; % максимальное количество эпох обучения
  
   er_hist = [] ; % история изменения ошибки	 
   for j = 1:n,
      l = lstm_loss(Xc,W,yc) ;
      er_hist = [ er_hist , l ] ;
      printf("[i] эпоха %i/%i, ошибка обучения: %f/%f     \r",j,n, l,er_max) ;
      if l < er_max, break; endif
      dW = lstm_gradient(X,W,y) ; % вычисляем значения градиента 
      dW = lstm_weight_norm(dW) ; % нормируем градиент
      W = lstm_weight_correct(W,dW,a) ; % изменяем веса
   endfor 
   printf("\n");

endfunction

% - - - - - - - - - - - - - - - - 
function retval = lstm_weight_correct(W,dW,a),
   W{1}.forget.x -= a * dW{1}.forget.x ;
   W{1}.forget.y -= a * dW{1}.forget.y ;
   W{1}.forget.c -= a * dW{1}.forget.c ;
   W{1}.forget.b -= a * dW{1}.forget.b ;

   W{1}.input.x -= a * dW{1}.input.x ;
   W{1}.input.y -= a * dW{1}.input.y ;
   W{1}.input.c -= a * dW{1}.input.c ;
   W{1}.input.b -= a * dW{1}.input.b ;

   W{1}.output.x -= a * dW{1}.output.x ;
   W{1}.output.y -= a * dW{1}.output.y ;
   W{1}.output.c -= a * dW{1}.output.c ;
   W{1}.output.b -= a * dW{1}.output.b ;

   W{1}.mem.x -= a * dW{1}.mem.x ;
   W{1}.mem.y -= a * dW{1}.mem.y ;
   W{1}.mem.b -= a * dW{1}.mem.b ;

   retval = W ;
endfunction


