%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: lstm_fit_gd.m,v 1.2 2017/06/28 08:49:10 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - 
% метод простого градиентного спуска
function [W,er_hist] = lstm_fit_gd(W,X,y,Xc,yc),
   a = 0.001 ; % скорость обучения
   er_max = 0.07 ; % порог допустимой ошибки
   n = 12e3 ; % максимальное количество эпох обучения
  
   printf("[i] обучение методом простого градиентного спуска...\n");
   er_hist = [] ; % история изменения ошибки	 
   for j = 1:n,
      l = lstm_loss(Xc,W,yc) ;
      er_hist = [ er_hist , l ] ;
      printf("\tэпоха %i/%i, ошибка обучения: %f/%f, скорость: %f        \r",j,n, l,er_max,a) ;
      if l < er_max, break; endif
      dW = lstm_gradient(X,W,y) ; % вычисляем значения градиента 
      dW = lstm_weight_norm(dW) ; % нормируем градиент
      W = lstm_weight_correct(W,dW,a) ; % изменяем веса
   endfor 
   printf("\n");

endfunction

