%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: lstm_forward.m,v 1.9 2017/06/28 08:49:10 mechanoid Exp mechanoid $



% - - - - - - - - - - - - - - - - 
function retval = lstm_forward(X,W),
   n = size(X,1) ; % размер одного элемента последовательности
   m = size(X,2) ; % длинна последовательности
   k = size(X,3) ; % количество примеров

   ys = size( W{1}.mem.b, 1 ) ; % размер слоя lstm

   Y = zeros(ys,k) ; % начальное значение выходов 
   C = zeros(ys,k) ; % начальное состояние памяти

   for t = 1:m,
      Xt = reshape( X(:,t,:) , [n,k] ) ; % элементы последовательностей номер t для всех примеров 

      Z = tanh( W{1}.mem.x * Xt + W{1}.mem.y * Y + W{1}.mem.b ) ;
      
      gf = sigmoid( W{1}.forget.x * Xt + W{1}.forget.y * Y + C .* W{1}.forget.c + W{1}.forget.b ) ; % гейт памяти (forget)
      gi = sigmoid( W{1}.input.x  * Xt + W{1}.input.y  * Y + C .* W{1}.input.c  + W{1}.input.b ) ; % гейт обновления (input)

      C = Z .* gi + C .* gf ; % обновляем память
	
      go = sigmoid( W{1}.output.x*Xt + W{1}.output.y*Y + C.*W{1}.output.c + W{1}.output.b ) ; % гейт выхода (output) 

      Y = tanh( C ) .* go ; % выход 
   endfor
  
   retval = Y;

endfunction


