%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: lstm_weight_init.m,v 1.8 2017/06/28 08:49:10 mechanoid Exp mechanoid $


% - - - - - - - - - - - - - - - - 
function retval = lstm_weight_init(s), 

   sx = s(1) ; % размер входа
   sy = s(2) ; % размер скрытого (lstm) слоя
   	 
   # веса lstm (скрытого) слоя 
   W{1}.forget.x = normrnd(zeros(sy,sx),ones(sy,sx)*1e-2) ; % матрица весов forget гейта
   W{1}.forget.y = normrnd(zeros(sy,sy),ones(sy,sy)*1e-2) ; % матрица весов обратных связей
   W{1}.forget.c = normrnd(zeros(sy,1),ones(sy,1)*1e-2) ; % вектор весов обратных связей  (peephole)
   W{1}.forget.b = zeros(sy,1) ; % сдвиги forget гейта
   
   W{1}.input.x = normrnd(zeros(sy,sx),ones(sy,sx)*1e-2) ; % матрица весов input гейта
   W{1}.input.y = normrnd(zeros(sy,sy),ones(sy,sy)*1e-2) ; % матрица весов обратных связей
   W{1}.input.c = normrnd(zeros(sy,1),ones(sy,1)*1e-2) ; % вектор весов обратных связей  (peephole)
   W{1}.input.b = zeros(sy,1) ; % сдвиги input гейта
  
   W{1}.output.x = normrnd(zeros(sy,sx),ones(sy,sx)*1e-2) ; % матрица весов ouput гейта
   W{1}.output.y = normrnd(zeros(sy,sy),ones(sy,sy)*1e-2) ; % матрица весов обратных связей
   W{1}.output.c = normrnd(zeros(sy,1),ones(sy,1)*1e-2) ; % вектор весов обратных связей  (peephole)
   W{1}.output.b = zeros(sy,1) ; % сдвиги ouput гейта

   W{1}.mem.x = normrnd(zeros(sy,sx),ones(sy,sx)*1e-2) ; % матрица весов обновления памяти
   W{1}.mem.y = normrnd(zeros(sy,sy),ones(sy,sy)*1e-2) ; % матрица весов обратных связей
   W{1}.mem.b = zeros(sy,1) ; % сдвиги обновления памяти

   retval=W;

endfunction


