%!octave 
%
%
%
%       OS : GNU/Linux 4.2.5
% COMPILER : GNU Octave, version 4.0.0
%
%   AUTHOR : Evgeny S. Borisov
%
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: lstm_weight_norm.m,v 1.4 2017/06/28 08:49:10 mechanoid Exp mechanoid $

% - - - - - - - - - - - - - - - - 
function retval = lstm_weight_norm(W),
  
   % разворачиваем матрицы в вектор
   v = [
      reshape( W{1}.forget.x, [ prod(size(W{1}.forget.x)),1 ] ) ;
      reshape( W{1}.forget.y, [ prod(size(W{1}.forget.y)),1 ] ) ;
      W{1}.forget.c ;
      W{1}.forget.b ;
      reshape( W{1}.input.x, [ prod(size(W{1}.input.x)),1 ] ) ;
      reshape( W{1}.input.y, [ prod(size(W{1}.input.y)),1 ] ) ;
      W{1}.input.c ;
      W{1}.input.b ;
      reshape( W{1}.output.x, [ prod(size(W{1}.output.x)),1 ] ) ;
      reshape( W{1}.output.y, [ prod(size(W{1}.output.y)),1 ] ) ;
      W{1}.output.c ;
      W{1}.output.b ;
      reshape( W{1}.mem.x, [ prod(size(W{1}.mem.x)),1 ] ) ;
      reshape( W{1}.mem.y, [ prod(size(W{1}.mem.y)),1 ] ) ;
      W{1}.mem.b ;
      ] ;

   nv = norm(v) ; % общая норма

   % нормируем значения весов W
   W{1}.forget.x /= nv ;
   W{1}.forget.y /= nv ;
   W{1}.forget.c /= nv ;
   W{1}.forget.b /= nv ;
   
   W{1}.input.x /= nv ;
   W{1}.input.y /= nv ;
   W{1}.input.c /= nv ;
   W{1}.input.b /= nv ;
  
   W{1}.output.x /= nv ;
   W{1}.output.y /= nv ;
   W{1}.output.c /= nv ;
   W{1}.output.b /= nv ;

   W{1}.mem.x /= nv ;
   W{1}.mem.y /= nv ;
   W{1}.mem.b /= nv ;

   retval = W ;

endfunction




